/*
 * Component Name: WAS.isc.isclite.cp
 * 
 * Licensed Materials - Property of IBM
 * 5724-I63, 5724-H88, 5655-N02, 5733-W70 
 * Copyright IBM Corp. 2006, 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 * 
 */
 
/***************************************************************************************************************************************************************/
/************************************Portlet Refresh  specific global variables*********************************************************************************/
    
var iscPrPopupMenuTimer                             = null;                                 // the Refresh Popup menu timer
var iscPrPopupMenuActiveId                          = null;                                 // the active Refresh Popup menu - the currently shown

var iscPrPortletNamePrefix                          = "iscPortlet_";                        // the Refreshable Portlet DOM id prefix
var iscPrPortletTimerPreefixName                    = "iscPortletRefreshTimer_";            // the Refreshable Portlet timer DOM id prefix
var iscPrPortletRefreshMenuPrefixName               = "iscPortletRefreshMenu_";             // the Refreshable Portlet Popup div id prefix
var isPrPortletRefreshPopupPausePrefixName			= "iscPortletRefreshMenuPause_";		// the Refreshable Portlet Pause Popup menu option prefix
var iscPrPortletDisableDivPrefix                    = "iscPortletDisableDiv_";
var iscPrPortletDisableIframePrefix                =  "iscPortletDisableIframe_";
var iscPrPortletWrapperDivPrefix                    = "iscPortletWrapperDiv_";
var iscPrPortletNameDelimiter		  				= ";";

var	iscPrUrl                                        = '/ibm/console/pra.do';                // Portlet Refresh action url
var iscPrHttpMethod                                 = 'POST';

var iscPrRefreshablePortletsArray                   =  [];                         // array that stores all the Refreshable Portlets per current page
var iscPrPageId                                     =  "";                                  // the pageId of the current refreahble page 

var isPageEnabledForRefresh                         = false;   
var isPrNlsArray									= null;
var iscPrUpdatePopupMenuTimer                       = null;
var iscPrGlobalRefreshTimer                         = null;
    
var iscPrGlobalScope                                = this;
var iscPrBiggestZIndex                              = 0;
var iscPrInit                                       = false;
var iscPrPortletDisableDivZIndexAddition            = 10;
var iscPrPopupMenuZIndexAddition                    = 20;
var iscPrRefreshablePortletsRemoveOnOnload          = [];

var iscDebug					    = false;
/************************************end of Portlet Refresh  specific global variables**************************************************************************/
/***************************************************************************************************************************************************************/

/***************************************************************************************************************************************************************/
/************************************Portlet Refresh  Util functions********************************************************************************************/


/*	
 * get an element by passing the parrent and the element id 
 */ 
function iscPrGetElementById(element, id){

    var result=null;
    try{
        if (element.id==id) {
            return(element);
        }
        if (element.hasChildNodes()) {
            var children = element.childNodes;
            for (i = 0; i < children.length; i++) {
                result=iscPrGetElementById(children[i],id);
                if (result!==null) {
                    return(children[i]);
                }
            }
        }
    }catch(e){
	//no id
    }
    return(result);

}
    
/*	
 * convert seconds to time format - hh:mm:ss format 
 */   
function iscPrSec2hms(t){

    var theTime = "00:00:00";
    if(t>0){
        var rest = t % 3600;
        
        var hours = t / 3600;
        hours =  Math.floor(hours);
        hours=(hours<10) ? '0'+hours : hours;
    
        var minutes = rest/60;
        minutes =  Math.floor(minutes);
        minutes=(minutes<10) ? '0'+minutes : minutes;
        
        var seconds = rest%60;
        seconds=(seconds<10) ? '0'+seconds : seconds;
        
        theTime = hours+":"+minutes+":"+seconds;
    }
    return theTime;
}//end of iscPrSec2hms(t)

/*	
 * check if a String contains only digits 
 */   
function iscPrIsInteger(s){

    if(s.length<=0){
      return false;
    }
    
    for (i = 0; i < s.length; i++){   
        var c = s.charAt(i);
        if (((c < "0") || (c > "9"))) {
          return false;
        }
    }
    return true;
}// end of iscPrIsInteger(s)

/*	 
 * create ISC Portlet Refresh XMLHttpRequest 
 */ 
function iscPrCreateXMLHttpRequest() {
      
        var iscPrXmlHttpRequest              = false; //the Ajax request used by Portlet Refresh mechanism
      

          try {
            iscPrXmlHttpRequest = new XMLHttpRequest();
          } catch (trymicrosoft) {
            try {
              iscPrXmlHttpRequest = new ActiveXObject("Msxml2.XMLHTTP");
            } catch (othermicrosoft) {
              try {
                iscPrXmlHttpRequest = new ActiveXObject("Microsoft.XMLHTTP");
              } catch (failed) {
                iscPrXmlHttpRequest = false;
              }
            }
        }

      
      return iscPrXmlHttpRequest;
      
}// end of iscPrCreateXMLHttpRequest()

/*	 
 * find the upper left corner coordinates of a given element 
 */ 
function iscPrFindPos(obj) {

    var curleft = 0;
    var curtop = 0;
    if (obj.offsetParent) {
        curleft = obj.offsetLeft;
        curtop = obj.offsetTop;
        while (obj = obj.offsetParent) {
            curleft += obj.offsetLeft;
            curtop += obj.offsetTop;
        }
    }
    return [curleft,curtop];
    
}// end of iscPrFindPos(obj)

/*	 
 * check if an element is a child of an other element 
 */ 
function iscPrContains(parent,child){

    if (!child) {
        return; 
    }
    
    while ( child = child.parentNode ) {
      if ( child == parent ) {
        return true;
      }
    }
    
    return false;
}// end of iscPrContains(parent,child)

/* 
 *this object represent the Screen properties 
 */
function iscPrScreen(){
     this.width     = 0;
     this.height    = 0;
     this.scrollX   = 0;
     this.scrollY   = 0;   
    
    this.getWidth   =_getWidth;
    this.getHeight  =_getHeight;
    this.getScrollX =_getScrollX;
    this.getScrollY =_getScrollY;
    this.calcAll    =_calcAll;
    
    this.calcAll();
    
    /*	 calculate the screen width */ 
    function _getWidth(){
    
        this.width = 0;
        if (window.innerWidth) {
            this.width = window.innerWidth - 18;
        }else if (document.documentElement && document.documentElement.clientWidth) {
              this.width = document.documentElement.clientWidth;
        }else if (document.body && document.body.clientWidth) {
              this.width = document.body.clientWidth;
        }
        
    }//end of _getWidth()
    
    /*	 calculate the screen height */ 
    function _getHeight(){
    
        this.height = 0;
        if (window.innerHeight) {
            this.height = window.innerHeight - 18;
        }else if (document.documentElement && document.documentElement.clientHeight) {
              this.height = document.documentElement.clientHeight;
        }else if (document.body && document.body.clientHeight) {
              this.height = document.body.clientHeight;
        }
        
    }// end of _getHeight()
    
     /*	 calculate scroll horizontal position */ 
    function _getScrollX(){
    
        this.scrollX = 0;
          if (typeof window.pageXOffset == "number") {
            this.scrollX = window.pageXOffset;
          }else if (document.documentElement && document.documentElement.scrollLeft){
              this.scrollX = document.documentElement.scrollLeft;
          }else if (document.body && document.body.scrollLeft) {
              this.scrollX = document.body.scrollLeft; 
          }else if (window.scrollX) {
            this.scrollX = window.scrollX;
         }
         
    }// end of _getScrollX()
    
     /*	 calculate scroll vertical position */ 
    function _getScrollY(){
    
        this.scrollY = 0;    
        if (typeof window.pageYOffset == "number") {
            this.scrollY = window.pageYOffset;
        }else if (document.documentElement && document.documentElement.scrollTop){
              this.scrollY = document.documentElement.scrollTop;
        }else if (document.body && document.body.scrollTop) {
              this.scrollY = document.body.scrollTop; 
        }else if (window.scrollY) {
            this.scrollY = window.scrollY;
        }
        
    }// end of _getScrollY()
    
   /* calculate all the screen properties */
    function _calcAll(){
    
        this.getWidth(); 
        this.getHeight();
        this.getScrollX();  
        this.getScrollY();
        
    }// end of _calcAll()

}// end of iscPrScreen()
function iscPrSetNlsStrings(nlsArray){
	if(nlsArray!=null){
		isPrNlsArray = nlsArray;
	}else{
		// default
		isPrNlsArray = new Array("Refreshing ...","Pause Refresh","Resume Refresh");
	}
}

// do Pause or resume refresh depending on portlet.refreshState value and hide teh menu
// it is intended to be invoked from the Portlet Refresh Popup menu
// oid - the unique name of the portlet
function iscPrDoPauseResumeRefresh(oid){

    var portlet = iscPrRefreshablePortletsArray[oid];
    if(!portlet){
        return;
    }
    if(portlet.refreshState=='paused'){
        portlet.refreshState='readyForRefresh';
        
    }else{
        portlet.refreshState='paused';
    }
    
    iscPrPopupMenuHide();
    
    // change  Pause/Resume nls
    var pauseMenuId = isPrPortletRefreshPopupPausePrefixName+oid;
    var nlsString = portlet.refreshState=='paused' ? isPrNlsArray[2] : isPrNlsArray[1];
   
    clearTimeout(iscPrUpdatePopupMenuTimer);
    iscPrUpdatePopupMenuTimer=setTimeout("document.getElementById('" + pauseMenuId + "').innerHTML = '"+nlsString+"'", 300);
   
    
    
}// end of iscPrDoPauseResumeRefresh(oid)


// do Manual Refresh and hide the menu
// it is intended to be used from the Portlet Refresh Popup menu
// oid - the unique name of the portlet
function iscPrDoManualRefresh(oid){

    var portlet = iscPrRefreshablePortletsArray[oid];
    if(!portlet){
        return;
    }
    
    iscPrDoRefresh(portlet)
    
    iscPrPopupMenuHide();
    
}// end of 

// regiter a portlet for Portlet Refresh
// it is intended to be invoked from Content.jsp
// oid - the portlet unique name
// refreshInterval - the portlet refresh interval
// refresh mode - the portlet refresh mode
// showTimer - boolean varaible that is used fo find out id the timer will be shown at the portlet title bar
function iscPrRegiterPortletForRefresh(refreshPageId,portletId,refreshInterval,refreshMode,showTimer){

		var portletIdArray      =   portletId.split(iscPrPortletNameDelimiter);
        var oid                 =   portletIdArray[1];
        
        if(!iscPrRefreshablePortletsArray[oid]){
            var portletToRegiter = new IscPrRefreshablePortlet(portletId,refreshInterval,refreshMode,showTimer);
            iscPrRefreshablePortletsArray[oid]=portletToRegiter;
        }
       
        
        iscPrInitPage();
        iscPrPageId = refreshPageId;
        
        // start PortletRefresh timer
        if(!isPageEnabledForRefresh){
             iscPrRefreshCounterCallback();
             isPageEnabledForRefresh=true;
        }
       
        
}//end of iscPrRegiterPortletForRefresh(oid,refreshInterval,refreshMode,showTimer)



function iscPrInitPage(){
     if(!iscPrInit){
     
        //  append  onload hadler
        var prevOnload = window.onload;
        window.onload = function() { 
            if(prevOnload){
                prevOnload(); 
            }
            iscPrBiggestZIndex=iscPrGetBiggestZIndex(document); // to calculate the biggest z-index on the page
                               
        }
        
        // apppend on resize handler 
        var prevOnResize =  window.onresize;
         window.onresize = function(){
             if(prevOnResize){
                prevOnResize(); 
            }
            iscPrResizeDisableDivs(); // to resize cover divs while portlet is refreshing and the user resize the frame
        } 
         
        // apppend onunload  handler 
        var prevOnUnload = window.onunload;
        window.onunload = function() { 
            if(prevOnUnload){
                prevOnUnload(); 
            }
           iscPrCleanOnUnload();
        } 
         
        
        iscPrInit=true;
    }
}
// callback function that is invoked on eber one seconds
// it iterates trough all the portlets registered for refresh and 
// invokes doRefresh method of every portlet that need to be refreshed
function iscPrRefreshCounterCallback(){
    
    if(iscPrGlobalRefreshTimer){
        clearTimeout(iscPrGlobalRefreshTimer);
    }
    for (var i in iscPrRefreshablePortletsArray) { 
    
        var portlet = iscPrRefreshablePortletsArray[i];
        var portletRefreshSettings = portlet.refreshSettings;
    
        if((portlet.refreshState=="readyForRefresh") && (portletRefreshSettings.refreshMode!="none") ){

            if(portlet.remainingInterval>0){
        
                if(portlet.remainingInterval==1){
                   iscPrDoRefresh(portlet);
                }else{
                    iscPrDoUpdateTimer(portlet,portlet.remainingInterval-1);
                }
            }
        }
        
    }
   
   var callBackFunc = "iscPrRefreshCounterCallback()";
   iscPrGlobalRefreshTimer = window.setTimeout(callBackFunc,1000);
   
}// end of iscPrRefreshCounterCallback()

/************************************end ortlet Refresh  Util functions*****************************************************************************************/
/***************************************************************************************************************************************************************/   

/***************************************************************************************************************************************************************/
/************************************Popup menus core functions*************************************************************************************************/
    
// dipslay a Popup menu
// id - the id of the div to be shown
// e - the event 
function iscPrPopupMenuShow(id, e,isBidiLayout){

    var menuObj = document.getElementById? document.getElementById(id): null;
    if (!menuObj) {
        return;
    }
    
    iscPrPopupMenuActiveId=id;
    
    if ( menuObj.onmouseout == null ) {
        menuObj.onmouseout = iscPrPopupMenuOnOutHandler;
    }
    
    if ( menuObj.onmouseover == null ) {
        menuObj.onmouseover = iscPrPopupMenuClearTimer;
    }
    
    
    // for accesibility
    if ( menuObj.onblur == null ) {
        menuObj.onblur = iscPrPopupMenuOnOutHandler;
    }
    
    if ( menuObj.onfocus == null ) {
        menuObj.onfocus  = iscPrPopupMenuClearTimer;
    }
    
    anchorArray = menuObj.getElementsByTagName("a") ; 
    for  ( i = 0; i  <  anchorArray.length; i++ )  {
          
         currElement =   anchorArray[i];
          
          if ( currElement.onblur == null ) {
            currElement.onblur = iscPrPopupMenuOnOutHandler;
          }
    
          if ( currElement.onfocus == null ) {
             currElement.onfocus  = iscPrPopupMenuClearTimer;
          }
    } 
    
    iscPrPopupMenuPosition(menuObj,e,isBidiLayout);
    document.getElementById(iscPrPopupMenuActiveId).style.zIndex=iscPrBiggestZIndex+iscPrPopupMenuZIndexAddition;
    iscPrPopupMenuTimer=setTimeout("document.getElementById('" + iscPrPopupMenuActiveId + "').style.visibility = 'visible'", 200);
    
}// end of iscPrPopupMenuShow(id, e)

// hide a Popup menu
function iscPrPopupMenuHide(){

     iscPrPopupMenuClearTimer();
     if (iscPrPopupMenuActiveId && document.getElementById) {
      iscPrPopupMenuTimer = setTimeout("document.getElementById('"+iscPrPopupMenuActiveId+"').style.visibility = 'hidden'", 200);
     }
    
}// end of iscPrPopupMenuHide()


// caclulate and set the position of the Popup menu
// menu - the div object corresponding to the menu
// ev- used to calculate the menu position on the screen
function iscPrPopupMenuPosition(menu,e,isBidiLayout){
    
    var refreshIcon = e.target? e.target: e.srcElement;
    if(refreshIcon.tagName=='A'){// the refresh link  - when keyboard is used 
        refreshIcon = refreshIcon.firstChild;
    }

    var refreshIconPosition = iscPrFindPos(refreshIcon);

    var x = refreshIconPosition[0];
    var y = refreshIconPosition[1];
    

    var screenProps = new iscPrScreen();
    
    //var skipX = false;
    // calculate menu left position
    if(!isBidiLayout){ // for left to right languages
        var showLeft = true;// show on the left - default
        if((x - menu.offsetWidth)<screenProps.scrollX){// no enough place to show the menu left on the refresh icon
            // check if there is enough space at the right of the refresh icon
            if((x+refreshIcon.width+menu.offsetWidth)<(screenProps.scrollX+screenProps.width)){
                   showLeft =false; // there is enough space at the right of the refresh icon
            }
        }
        x = (showLeft) ? (x - menu.offsetWidth) : (x+refreshIcon.width);
       
    }else{// for right to left languages
        var showRight = true;// show on the right - default
        
        if(!document.all){// for Firefox 
            if((x+refreshIcon.width+menu.offsetWidth)>(screenProps.scrollX+screenProps.width)){// no enough place to show the menu right on the refresh icon
                // check if there is enough space at the left of the refresh icon
                if((x-refreshIcon.width-menu.offsetWidth)>(screenProps.scrollX)){
                            showRight=false;// there is enough space at the left of the refresh icon
                }
            }
        }else{// for IE
           // do nothing - always display the popup menu on left side
        }
        
      x = (showRight) ? (x+refreshIcon.width) : (x-refreshIcon.width-menu.offsetWidth);
      
    }

    // caculate menu top position
    var showUnder =true;// show the menu under the refresh icon - default
    if((y+menu.offsetHeight)>(screenProps.height+screenProps.scrollY)){// no enough place to show the menu under the refresh icon
        showUnder = false;
        // check if there is enough space above the refresh icon
        if((y-menu.offsetHeight+refreshIcon.height)<(screenProps.scrollY)){
             showUnder = true;// there is enough space above the refresh icon
        }
    }
                 // for Firefox and Opera
    var yKoef = (!window.event || window.opera) ? 2 : 0;
    y = (showUnder)  ? (y-yKoef)  : (y-menu.offsetHeight+refreshIcon.height+yKoef) ;
    

    // set the div menu left and top positions
    menu.style.left = x + "px"; 
    menu.style.top  = y + "px";
    
}// end of iiscPrPopupMenuPosition(menu,e)



// callback function invoked on onmouseout over the popup menu
function iscPrPopupMenuOnOutHandler(e){

    e = e? e: window.event;
    var menuObj = document.getElementById(iscPrPopupMenuActiveId);
    var targElement = e.relatedTarget? e.relatedTarget: e.toElement;
    if ( menuObj != targElement && !iscPrContains(menuObj,targElement )) {
        iscPrPopupMenuHide();
    }
    
}// end of scPrPopupMenuOnMouseOutHandler(e)

// reset the popup menu timer
function iscPrPopupMenuClearTimer(){

   if (iscPrPopupMenuTimer) {
        clearTimeout(iscPrPopupMenuTimer);
    }
    
}// end of iscPrPopupMenuClearTimer()
    
/************************************end of Popup menus core functions******************************************************************************************/
/***************************************************************************************************************************************************************/   
    
/***************************************************************************************************************************************************************/
/************************************Portlet Refresh object*****************************************************************************************************/


/*
 * object that represent Refreshable Settings of a portlet
 */ 
function IscPrRefreshSettings(refreshInterval,refreshMode,showTimer){
    
    this.refreshInterval=refreshInterval;
    this.refreshMode=refreshMode;
    this.showTimer=showTimer;
    
}
/*
 * A Refreshable object constructor
 */
function IscPrRefreshablePortlet(portletId,refreshInterval,refreshMode,showTimer){

	this.id                             =   portletId;
    this.oid                            =   null;
    this.remainingInterval              =   null;
    this.timerId                        =   null;
    this.httpParameters                 =   null;
    this.refreshState                   =   null;
    
    this.refreshSettings = new IscPrRefreshSettings(refreshInterval,refreshMode,showTimer);
     
    var portletIdArray          =   this.id.split(iscPrPortletNameDelimiter);
    this.oid                    =   portletIdArray[1];
    this.timerId                =   iscPrPortletTimerPreefixName+this.oid;
    this.remainingInterval      =   this.refreshSettings.refreshInterval;
    this.refreshState           =   "readyForRefresh";
    
    if(!(this.refreshSettings.refreshMode=='none')){
        	iscPrDoUpdateTimer(this,this.remainingInterval);
    }
       
    
}// end of IscPrRefreshablePortlet 

/************************************end of Portlet Refresh object************************************************************************************/
/***************************************************************************************************************************************************************/

function iscPrDoRefresh(portlet){
    try{              
            if(portlet.refreshState=="refreshing"){
                return;  // do not send multipe portlet refresh ajax requests
            }
            portlet.refreshState="refreshing";
            iscPrDoUpdateTimer(portlet,isPrNlsArray[0]);
            
            // add cover div  over rge portlet body. 
            //It will disable user interaction with the portlet while refresh is running
            iscPrDisablePortlet(portlet.id,true);         
           
            var xmlHttpRequest = iscPrCreateXMLHttpRequest();
            if(!xmlHttpRequest){
            	iscPrDisablePortlet(portlet.id,false); /** @ndp - unblock protelt covering div **/
               alert("Cannot create XMLHttp Request");
               return;
            }

            var prevOnUnload = window.onunload;
            window.onunload = function() { 
                if(prevOnUnload){
                    prevOnUnload(); 
                }
                iscPrAjaxCallAborter(xmlHttpRequest); 
            } 

            
            if(!portlet.httpParameters){
                portlet.httpParameters         =   "oid="+portlet.oid+"&pageID="+iscPrPageId+"&refreshMode="+portlet.refreshSettings.refreshMode+"&XSS="+parent.parent.navigation.document.navFilter.XSS.value;
            }
           
            
            var ajaxResponseHandler = function() { 
				try{
	                if (xmlHttpRequest.readyState == 4){
	                    if (xmlHttpRequest.status == 200){
	                    
	                        portletInnerHtml= xmlHttpRequest.responseText;
	                        portletInnerHtml= portletInnerHtml.replace(/^\s*|\s*$/g,"");
	                        
	          
	                        iscPrDoUpdateBody(portlet,portletInnerHtml);
	                             
	                        
	                        
	                    }else if (portlet.xmlHttpRequest.status == 404){
	                         alert("Portlet Refresh request URL does not exist : "+iscPrUrl);
	                    }else{
	                         alert("Portlet Refresh error: status code is " + xmlHttpRequest.status);
	                    }
	                    
	                    xmlHttpRequest = null;
	                }
				}catch(err){
					iscPrDisablePortlet(portlet.id,false); /** @ndp - unblock protelt covering div **/
				        if (iscDebug) {
					    alert("No xmlHttpRequest created: "+err); 
					}
					 // do nothing xmlHttpRequest is still not created
				}   
            };
            
            xmlHttpRequest.onreadystatechange=ajaxResponseHandler;
            
            xmlHttpRequest.open(iscPrHttpMethod, iscPrUrl, true);
            xmlHttpRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            xmlHttpRequest.setRequestHeader("Content-length", portlet.httpParameters.length);
            xmlHttpRequest.setRequestHeader("Connection", "close");
            xmlHttpRequest.send(portlet.httpParameters);
           

           
       }catch(error){
            iscPrDoUpdateTimer(portlet,"");
	        if (iscDebug) {
		    alert("Unable to refresh portlet: " +error);
		}
       }
}

/*
 *  update the portlet body including the title bar
 *  @param data - the portlet body as a text
 */
function iscPrDoUpdateBody ( portlet,data ){

        
       if(data && data.length>0){
          var portletDomEl = document.getElementById(portlet.id);
          
           if(portletDomEl){
                   
                    if(document.getElementById && document.all){
                        iscPrPurge(portletDomEl);
                        
                        // remove script elements before remove the element
                        var scriptElements = portletDomEl.getElementsByTagName("script");
                        for(var i in scriptElements){
                            if(scriptElements[i].innerHTML || scriptElements[i].src){
                                iscPrDiscardElement(scriptElements[i]);
                            }
                        }

                        
                    }
                    
                    
                    
                    newId = portletDomEl.id+";old";
                    portletDomEl.id=newId;
                    
                    iscPrAddCleanOnUnload(newId);
                    
                    //create wrapping div
                    var portletWrapperDiv = document.getElementById(iscPrPortletWrapperDivPrefix+portlet.id);
                    if (!portletWrapperDiv) {
                        
                        portletWrapperDiv=document.createElement("DIV");
                        portletWrapperDiv.id = iscPrPortletWrapperDivPrefix+portlet.id;
                        iscPrAddCleanOnUnload(iscPrPortletWrapperDivPrefix+portlet.id);
                        
                        portletWrapperDiv.style.display = 'none';
                        document.body.appendChild(portletWrapperDiv);
                        
                        
                    }
                    
                    portletWrapperDiv.innerHTML=data;
                    var pElement=iscPrGetElementById(portletWrapperDiv,portlet.id);
                    iscPrAddCleanOnUnload(pElement.id);
                    
                    if(document.getElementById && document.all){
                       
                        portletDomEl.parentNode.insertBefore(pElement, portletDomEl);

                        portletDomEl.outerHTML="";
                        iscPrDiscardElement(portletDomEl);
                        
                    }else{
                    
                        var replaced = portletDomEl.parentNode.replaceChild(pElement,portletDomEl);
                        if(replaced.parentNode){
                            replaced.parentNode.removeChild(replaced);
                        }
                        
                    }
                    
                    // exec scripts
                    var scriptElements = pElement.getElementsByTagName("script");
		    try{
                        for(var i in scriptElements){
                            if(scriptElements[i].innerHTML){
                               iscPrGlobalScope.eval(scriptElements[i].innerHTML);
                            }
                        }
                    }catch(err) {
		        if (iscDebug) {
			    alert("An error occurred while performing eval() on the following script element:\n\n"+scriptElements[i].innerHTML);
			}
		    }
                    portletWrapperDiv.innerHTML="";
                    portletDomEl =null;
                    portletWrapperDiv=null;

                    
                    iscPrBiggestZIndex=iscPrGetBiggestZIndex(pElement);
                    
                   scriptElements=null;
                   pElement =null;
                    
                   
           }
        }
        
        // remove cover div  over the portlet body. 
        // Since refresh is finished we should give the user ability to interact with the portlet
        iscPrDisablePortlet(portlet.id,false);   
        
        portletDomEl =null;
        portlet.remainingInterval    =   portlet.refreshSettings.refreshInterval;
        portlet.refreshState           =   "readyForRefresh";
    
        if(!(portlet.refreshSettings.refreshMode=='none')){
                iscPrDoUpdateTimer(portlet,portlet.remainingInterval);
        }
        
}// end of IscPrRefreshablePortlet.prototype.doUpdateBody

function iscPrDoUpdateTimer(portlet,t){
        if(t===null){
            t="";
        }
        
        var timerDomEl = document.getElementById(portlet.timerId);
        if(timerDomEl){
        
            var isInt = iscPrIsInteger(t);
            var timerValue="";
            
            if(portlet.refreshSettings.refreshMode=='none'){// in none refresh mode - do not show timer 
            
                timerValue= isInt ? "" : t; // show only Refreshing ... - in case user is doing manual refresh
            }else{ 
  
				if(portlet.refreshSettings.showTimer){
					timerValue = (isInt) ?  iscPrSec2hms(t) : t;
				}else{
					timerValue = (isInt) ? "" :  t;
				}
           
            }
            
            portlet.remainingInterval = (isInt) ? t : -1; // update the remaining interval
            timerDomEl.firstChild.nodeValue=timerValue;// always update the timer
        }
}

// used to abort ajax request on unload
function iscPrAjaxCallAborter( xmlHttpRequest ){
    try{
        xmlHttpRequest.abort();
    }catch(err){
    // do nothing
    }
}

// get the biggest z-index on teh current page
function iscPrGetBiggestZIndex(element){
     var biggestZIndex =0;
     var allSubElements = element.getElementsByTagName("*");
     for(i=0;i<allSubElements.length;i++){
        if(allSubElements[i].style.zIndex>biggestZIndex){
            biggestZIndex = allSubElements[i].style.zIndex;
        }
    }
     return biggestZIndex;
}

// resize  all cover divs on the way to overlap the whole portlet bodies
function iscPrResizeDisableDivs(){
    for(i in iscPrRefreshablePortletsArray){
        var currentPortlet = iscPrRefreshablePortletsArray[i];
        var portletId = currentPortlet.id;
        iscPrResizeDisableDiv(portletId);
        
    }
    
}

// resize  portlet cover div on the way to overlap the whole portlet body
function iscPrResizeDisableDiv(portletId){
        var disablePortletDivId = iscPrPortletDisableDivPrefix+portletId;
        var portletDomEl = document.getElementById(portletId);
        if(portletDomEl){
            var portletDisableDiv = document.getElementById(disablePortletDivId); 
            if(portletDisableDiv){
                
                    var portletDomElTable =null;
                    var portletDomElTableArray = portletDomEl.getElementsByTagName('table');
                    if(portletDomElTableArray && portletDomElTableArray.length>0){
                       portletDomElTable = portletDomElTableArray[0];
                    }
                    
                    portletDisableDiv.style.width=portletDomElTable.clientWidth;
                    portletDisableDiv.style.height=portletDomElTable.clientHeight;
                    
                    portletDomElTable =null;
            }
            portletDisableDiv=null;
        }
        portletDomEl= null;
        
}

// add/remove cover div over the portlet body - it will disable intraction with the portlet
function iscPrDisablePortlet(portletId,toDisable){
        var portletDomEl = document.getElementById(portletId);
        
        var isIE6 = window.XMLHttpRequest ? false : true;
        var useIframe = isIE6;
        if(toDisable){
        
                var portletDisableDiv = document.getElementById(iscPrPortletDisableDivPrefix+portletId);
                if (!portletDisableDiv) {
                    
                    portletDisableDiv=document.createElement("DIV");
                    portletDisableDiv.id = iscPrPortletDisableDivPrefix+portletId;
                
                    var portletDisableDivContentHtml =  null;
                    if(useIframe){
                        // use iframe on IE 6  to hide windowed objects
                        portletDisableDivContentHtml= "<iframe src='javascript:false;' id='"+iscPrPortletDisableIframePrefix+portletId+"' scrolling='no' frameborder='5' style='position:absolute; top:0px; left:0px; display:none;filter=progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0);' > </iframe>" ;
                        iscPrAddCleanOnUnload(iscPrPortletDisableIframePrefix+portletId);  
                        
                    }else{
                        // for firefox and IE 7 - there is not problem  with windowed objects
                        portletDisableDivContentHtml = "<table width='100%' height='100%'><tr><td width='100%' height='100%' onclikc='return false;'>&nbsp;</td></tr></table>";
                    }
                    
                    
                    portletDomEl.parentNode.insertBefore(portletDisableDiv,portletDomEl);
                    portletDisableDiv.innerHTML=portletDisableDivContentHtml;
                    iscPrAddCleanOnUnload(iscPrPortletDisableDivPrefix+portletId);  
                     
                }
               
                var portletDomElTable =null;
                var portletDomElTableArray = portletDomEl.getElementsByTagName('table');
                if(portletDomElTableArray && portletDomElTableArray.length>0){
                   portletDomElTable = portletDomElTableArray[0];
                }
                    
                portletDisableDiv.style.position = 'absolute';
                portletDisableDiv.style.margin=8;
                portletDisableDiv.style.display="none";
                portletDisableDiv.style.width=portletDomElTable.clientWidth;
                portletDisableDiv.style.height=portletDomElTable.clientHeight;
                portletDisableDiv.style.zIndex = iscPrBiggestZIndex;
                portletDisableDiv.style.zIndex=iscPrBiggestZIndex+iscPrPortletDisableDivZIndexAddition;
               // portletDisableDiv.style.backgroundColor="red";
                
                
                if(useIframe){
                    var portletDisableDivIFrame = portletDisableDiv.getElementsByTagName('iframe')[0];
                     portletDisableDiv.style.display = "block";
                    portletDisableDivIFrame.style.width = portletDisableDiv.offsetWidth;
                    portletDisableDivIFrame.style.height = portletDisableDiv.offsetHeight;
                    portletDisableDivIFrame.style.top = portletDisableDiv.style.top;
                    portletDisableDivIFrame.style.left = portletDisableDiv.style.left;
                    portletDisableDivIFrame.style.zIndex = portletDisableDiv.style.zIndex - 1;
                    // disbale context menu 
                    //do not give user ability to refresh the iframe using refresh option from the context menu

                    portletDisableDivIFrame.contentWindow.document.oncontextmenu = function(){return false};
                    portletDisableDivIFrame.style.display = "block";
                    portletDisableDivIFrame =null;
                }else{
                    portletDisableDiv.style.display = "block";
                }
                

            
        }else{
             // hide the div
             var portletDisableDiv = document.getElementById(iscPrPortletDisableDivPrefix+portletId);
             
             if(portletDisableDiv){
                    if(useIframe){
                        var portletDisableDivIFrame = portletDisableDiv.getElementsByTagName('iframe')[0];
                        portletDisableDivIFrame.style.display = "none";

                    }
                     
                     portletDisableDiv.style.display="none";
                    if(!isIE6){// do not remove the cover div - it will be reused on the next refresh
                        portletDisableDiv.innerHTML = '';  
                    }
                   
                    
                }
           
        }
        
}

function iscPrCleanOnUnload(){
     //var ar_ct = 0;
     for(var i in iscPrRefreshablePortletsRemoveOnOnload){
        var elId = i;
        var element = document.getElementById(elId);
        if(element){
            if(document.all){
                iscPrDiscardElement(element);
            }else{
                if(element.parentNode){
                    element.parentNode.removeChild(element);
                }
            }
            element =null;
        }
        //ar_ct++;
    }
   // alert(ar_ct);
}
function  iscPrAddCleanOnUnload(elId){

    iscPrRefreshablePortletsRemoveOnOnload[elId]=1;
}

/***************************************************************************************************************************************************************/
/************************************IE specific functions******************************************************************************************************/

iscPrDiscardElement = function (element) {
       var garbageBin = document.getElementById('IELeakGarbageBin');
       if (!garbageBin) {
               garbageBin = document.createElement('DIV');
               garbageBin.id = 'IELeakGarbageBin';
               garbageBin.style.display = 'none';
               document.body.appendChild(garbageBin);
       }
       
       // move the element to the garbage bin
       garbageBin.appendChild(element);
       garbageBin.innerHTML = "";
       
     
}
function iscPrPurge(d) {
    var a = d.attributes, i, l, n;
    if (a) {
        l = a.length;
        for (i = 0; i < l; i += 1) {
            n = a[i].name;
            if (typeof d[n] === 'function') {
                d[n] = null;
            }
        }
    }
    a = d.childNodes;
    if (a) {
        l = a.length;
        for (i = 0; i < l; i += 1) {
            iscPrPurge(d.childNodes[i]);
        }
    }
}

/************************************end of IE specific functions***********************************************************************************************/
/***************************************************************************************************************************************************************/
